#include "stdafx.h"
#include "apxDirectDraw.h"


apxDirectDraw_t::apxDirectDraw_t()
{
}

apxDirectDraw_t::~apxDirectDraw_t()
{
	EndProcedure();
}

void
apxDirectDraw_t::EndProcedure(void)
{
	if( lpDD != NULL )
	{
		if( lpDDSPrimary != NULL )
		{
			lpDDSPrimary->Release();
			lpDDSPrimary = NULL;
		}
		lpDD->Release();
		lpDD = NULL;
	}
}



BOOL
apxDirectDraw_t::Initialize(HWND hwnd,long t_width,long t_height,long t_depth)
{
	DDSURFACEDESC	ddsd;
	DDSCAPS			ddscaps;
	HRESULT			ddrval;
	HDC				hdc;

	_TCHAR *szFrontMsg="front message";
	_TCHAR *szBackMsg="front message";


	// create the main DirectDraw object
	ddrval = DirectDrawCreate( NULL, &lpDD, NULL );
	if( ddrval != DD_OK ) {
		apxDebugMessageBox("DirectDrawCreate",ddrval);
		return FALSE;
	}

	// Get exclusive mode
	ddrval = lpDD->SetCooperativeLevel( hwnd,DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
//	ddrval = lpDD->SetCooperativeLevel( hwnd,DDSCL_NORMAL );
	if(ddrval != DD_OK ) {
		apxDebugMessageBox("SetCooperativeLevel",ddrval);
		return FALSE;
	}

	ddrval = lpDD->SetDisplayMode( t_width, t_height, t_depth );
	if( ddrval != DD_OK ) {
		apxDebugMessageBox("SetDisplaymode",ddrval);
		return FALSE;
	}

	// Create the primary surface with 1 back buffer
	ZeroMemory(&ddsd,sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(DDSURFACEDESC);
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
						  DDSCAPS_FLIP | 
						  DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1;
	ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
	if( ddrval != DD_OK ) {
		apxDebugMessageBox("CreateSurface",ddrval);
		return FALSE;
	}

	// Get a pointer to the back buffer
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, 
														  &lpDDSBack);
	if( ddrval != DD_OK ) {
		apxDebugMessageBox("GetAttachedSurface",ddrval);
		return FALSE;
	}

	return TRUE;
}

BOOL
apxDirectDraw_t::CreatePalette(LPPALETTEENTRY lpPE)
{
	HRESULT	ddrval;

	ddrval=lpDD->CreatePalette(DDPCAPS_8BIT,lpPE,&lpDPAL,NULL);
	ddrval=lpDDSPrimary->SetPalette(lpDPAL);

	return TRUE;
}
